#include<iostream>
#include<vector>
#include<bitset>
#include<algorithm>

using namespace std;

const int MAXN = 5005;
const int offset = 1001;

bitset <MAXN> used[MAXN];

vector <pair <int, int>> jump = { {1, 0}, {-1, 0}, {0, 1}, {0, -1} };
void DFS(int x, int y)
{
    //cout << x << " " << y << '\n';

    used[x+offset][y+offset] = true;
    for(pair <int, int> d: jump)
    {
        if(used[x+d.first+offset][y+d.second+offset]==0) DFS(x+d.first, y+d.second);
    }
}

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    int n;
    int xa;
    vector <int> p;

    cin >> n >> xa;
    for(int i = 0;i<n;i++)
    {
        int x;
        cin >> x;

        p.push_back(x);
    }
    sort(p.begin(), p.end());

    int m;
    int xb;
    vector <int> q;

    cin >> m >> xb;
    for(int i = 0;i<m;i++)
    {
        int x;
        cin >> x;

        q.push_back(x);
    }
    sort(q.begin(), q.end());

    xb -= xa;
    xa = 0;

    /*
    if(xa+p.back()<=xb-q.back())
    {
        cout << p.size() + q.size() << '\n';
        return 0;
    }
    */

    for(int d: p)
    {
        for(int i = 0;i<=d;i++)
        {
            used[xa-d/2+offset][-d/2+i+offset] = 1;
            used[xa+d/2+offset][-d/2+i+offset] = 1;
        }

        for(int i = 0;i<=d;i++)
        {
            used[xa-d/2+i+offset][-d/2+offset] = 1;
            used[xa-d/2+i+offset][+d/2+offset] = 1;
        }
    }
    for(int d: q)
    {
        for(int i = 0;i<=d;i++)
        {
            used[xb-d/2+offset][-d/2+i+offset] = 1;
            used[xb+d/2+offset][-d/2+i+offset] = 1;
        }

        for(int i = 0;i<=d;i++)
        {
            used[xb-d/2+i+offset][-d/2+offset] = 1;
            used[xb-d/2+i+offset][+d/2+offset] = 1;
        }
    }

    int answer = 0;
    for(int d: p)
    {
        for(int x = xa-d/2;x<=xa+d/2;x++)
        {
            for(int y = -d/2;y<=d/2;y++)
            {
                if(used[x+offset][y+offset]==0)
                {
                    //cout << x << " " << y << " " << d << '\n';

                    answer++;
                    DFS(x, y);
                }
            }
        }
    }
    for(int d: q)
    {
        for(int x = xb-d/2;x<=xb+d/2;x++)
        {
            for(int y = -d/2;y<=d/2;y++)
            {
                if(used[x+offset][y+offset]==0)
                {
                    //cout << x << " " << y << " " << d << '\n';

                    answer++;
                    DFS(x, y);
                }
            }
        }
    }

    cout << answer << '\n';
}
