#include<iostream>
#include<vector>
#include<random>

//#include "Lgrader.cpp"
#include "multisort.h"

using namespace std;

mt19937 rnd(22);
const int MAXN = 2e4 + 5;

int a[MAXN], b[MAXN];

int randInRange(int l, int r)
{
    return rnd()%(r-l+1) + l;
}

void useResult(vector <int> &ask, int &lInd, int &rInd, int pivot)
{
    int pivotInd = -1;
    for(int j = 0;j<ask.size();j++)
    {
        if(ask[j]==a[pivot])
        {
            pivotInd = j;
            break;
        }
    }

    for(int i = 0;i<pivotInd;i++) b[lInd] = ask[i], lInd++;
    for(int i = ask.size()-1;i>pivotInd;i--) b[rInd] = ask[i], rInd--;
}

void quickSort(int l, int r, int k)
{
    //cout << l << " --- " << r << '\n';

    if(l>=r) return;
    if(r-l+1<=k)
    {
        //cout << "ok" << '\n';

        vector <int> ask;
        for(int i = l;i<=r;i++) ask.push_back(a[i]);

        compare(ask);
        for(int i = l, j = 0;i<=r;i++,j++) a[i] = ask[j];//, cout << ask[j] << '\n';
        return;
    }

    int pivot = randInRange(l, r);
    //cout << pivot << " " << a[pivot] << '\n';

    int lInd = l, rInd = r;
    for(int i = l;i<=r;)
    {
        //cout << " -> " << i << '\n';

        vector <int> ask = {a[pivot]};
        for(;i<=r;i++)
        {
            if(ask.size()==k) break;
            if(i==pivot) continue;

            ask.push_back(a[i]);
        }

        compare(ask);
        useResult(ask, lInd, rInd, pivot);
    }
    b[lInd] = a[pivot];

    //cout << "pivot: " << a[pivot] << '\n';
    for(int i = l;i<=r;i++) a[i] = b[i];//, cout << b[i] << " ";
    //cout << '\n';

    quickSort(l, lInd-1, k);
    quickSort(lInd+1, r, k);
}

vector <int> makeAnswer(int n)
{
    vector <int> out;
    for(int i = 0;i<n;i++) out.push_back(a[i]);

    return out;
}

vector<int> multisort(int n, int k)
{
    //cout << "n: " << n <<  '\n';

    for(int i = 0;i<n;i++) a[i] = i;
    quickSort(0, n-1, k);

    //for(int i = 0;i<n;i++) cout << a[i] << " ";
    //cout << '\n';

    return makeAnswer(n);
}

