#include<iostream>
#include<vector>
#include<random>
#include<algorithm>

//#include "Lgrader.cpp"
#include "multisort.h"

using namespace std;

mt19937 rnd(22);
const int MAXN = 2e4 + 5;

int a[MAXN], b[MAXN];

int randInRange(int l, int r)
{
    return rnd()%(r-l+1) + l;
}

bool useResult2Pivot(vector <int> &ask, vector <int> &L, vector <int> &MID, vector <int> &R, int pivot1, int pivot2)
{
    int ind1 = -1, ind2 = -1;
    for(int i = 0;i<ask.size();i++)
    {
        if(ask[i]==a[pivot1]) ind1 = i;
        if(ask[i]==a[pivot2]) ind2 = i;
    }

    for(int i = 0;i<min(ind1, ind2);i++) L.push_back(ask[i]);
    for(int i = min(ind1, ind2)+1;i<max(ind1, ind2);i++) MID.push_back(ask[i]);
    for(int i = max(ind1, ind2)+1;i<ask.size();i++) R.push_back(ask[i]);

    return (ind1<ind2);
}

void quickSort2Pivot(int l, int r, int k)
{
    //cout << l << " --- " << r << '\n';

    if(l>=r) return;
    if(r-l+1<=k)
    {
        vector <int> ask;
        for(int i = l;i<=r;i++) ask.push_back(a[i]);

        compare(ask);
        for(int i = l, j = 0;i<=r;i++,j++) a[i] = ask[j];//, cout << ask[j] << '\n';
        return;
    }

    int pivot1 = randInRange(l, r);
    int pivot2 = randInRange(l, r);
    while(pivot1==pivot2) pivot2 = randInRange(l, r);

    vector <int> L, R, MID;
    for(int i = l;i<=r;)
    {
        vector <int> ask = {a[pivot1], a[pivot2]};
        for(;i<=r;i++)
        {
            if(ask.size()==k) break;
            if(i==pivot1 || i==pivot2) continue;

            ask.push_back(a[i]);
        }

        compare(ask);
        bool res = useResult2Pivot(ask, L, MID, R, pivot1, pivot2);

        if(res==false) swap(pivot1, pivot2);
    }

    //cout << pivot1 << " %% " << pivot2 << '\n';
    //cout << L.size() << " " << MID.size() << " " << R.size() << '\n';

    int last = l, ind = l;
    for(int x: L) b[ind] = x, ind++;
    b[ind] = a[pivot1];ind++;
    pair <int, int> f1 = {last, ind-2};

    last = ind-1;
    for(int x: MID) b[ind] = x, ind++;
    b[ind] = a[pivot2];ind++;
    pair <int, int> f2 = {last, ind-2};

    last = ind-1;
    for(int x: R) b[ind] = x, ind++;
    pair <int, int> f3 = {last, ind-1};

    for(int i = l;i<=r;i++) a[i] = b[i];
    quickSort2Pivot(f1.first, f1.second, k);
    quickSort2Pivot(f2.first, f2.second, k);
    quickSort2Pivot(f3.first, f3.second, k);

    //quickSort2Pivot(last, ind-1)

    //quickSort2Pivot(l, lInd-1, k);
    //quickSort2Pivot(lInd+1, r, k);
}

void useResult(vector <int> &ask, int &lInd, int &rInd, int pivot)
{
    int pivotInd = -1;
    for(int j = 0;j<ask.size();j++)
    {
        if(ask[j]==a[pivot])
        {
            pivotInd = j;
            break;
        }
    }

    for(int i = 0;i<pivotInd;i++) b[lInd] = ask[i], lInd++;
    for(int i = ask.size()-1;i>pivotInd;i--) b[rInd] = ask[i], rInd--;
}

void quickSort(int l, int r, int k)
{
    //cout << l << " --- " << r << '\n';

    if(l>=r) return;
    if(r-l+1<=k)
    {
        vector <int> ask;
        for(int i = l;i<=r;i++) ask.push_back(a[i]);

        compare(ask);
        for(int i = l, j = 0;i<=r;i++,j++) a[i] = ask[j];//, cout << ask[j] << '\n';
        return;
    }

    int pivot = randInRange(l, r);

    int lInd = l, rInd = r;
    for(int i = l;i<=r;)
    {
        vector <int> ask = {a[pivot]};
        for(;i<=r;i++)
        {
            if(ask.size()==k) break;
            if(i==pivot) continue;

            ask.push_back(a[i]);
        }

        compare(ask);
        useResult(ask, lInd, rInd, pivot);
    }

    b[lInd] = a[pivot];
    for(int i = l;i<=r;i++) a[i] = b[i];//, cout << b[i] << " ";

    quickSort(l, lInd-1, k);
    quickSort(lInd+1, r, k);
}


vector <int> makeAnswer(int n)
{
    vector <int> out;
    for(int i = 0;i<n;i++) out.push_back(a[i]);

    return out;
}

vector<int> multisort(int n, int k)
{
    //cout << "n: " << n <<  '\n';

    for(int i = 0;i<n;i++) a[i] = i;
    shuffle(a, a+n, rnd);

    if(k!=2) quickSort2Pivot(0, n-1, k);
    else quickSort(0, n-1, k);
    //for(int i = 0;i<n;i++) cout << a[i] << " ";
    //cout << '\n';

    return makeAnswer(n);
}

