#include<iostream>
#include<vector>
#include<random>
#include<set>
#include<algorithm>

//#include "Lgrader.cpp"
#include "multisort.h"

using namespace std;

mt19937 rnd(22);
const int MAXN = 2e4 + 5;

int a[MAXN], b[MAXN];

int randInRange(int l, int r)
{
    return rnd()%(r-l+1) + l;
}

vector <int> useResultKPivots(vector <int> &ask, vector <vector <int>> &layers, set <int> &usedPivots)
{
    int seen = 0;
    vector <int> order;

    for(int i = 0;i<ask.size();i++)
    {
        if(usedPivots.count(ask[i])==true)
        {
            order.push_back(ask[i]);

            seen++;
            continue;
        }

        layers[seen].push_back(ask[i]);
    }

    return order;
}

int f(int x)
{
    if(x==2) return 1;
    if(x==3) return 2;
    if(x<20) return x/3;
    if(x<100) return x*0.2;
    if(x<1000) return x*0.1;
}

void quickSort2Pivot(int l, int r, int k)
{
    //cout << l << " --- " << r << '\n';

    if(l>=r) return;
    if(r-l+1<=k)
    {
        vector <int> ask;
        for(int i = l;i<=r;i++) ask.push_back(a[i]);

        compare(ask);
        for(int i = l, j = 0;i<=r;i++,j++) a[i] = ask[j];//, cout << ask[j] << '\n';
        return;
    }

    set <int> usedPivots;
    vector <int> pivots;

    for(int i = 0;i<f(k);i++)
    {
        int p = randInRange(l, r);
        while(usedPivots.count(a[p])==true) p = randInRange(l, r);

        pivots.push_back(a[p]);
        usedPivots.insert(a[p]);
    }

    vector <vector <int>> layers;
    layers.resize(pivots.size()+1);

    for(int i = l;i<=r;)
    {
        //cout << " ---- " << i << " " << pivots.size() << " " << k << '\n';

        vector <int> ask = pivots;
        for(;i<=r;i++)
        {
            if(ask.size()==k) break;
            if(usedPivots.count(a[i])==true) continue;

            ask.push_back(a[i]);
        }

        compare(ask);
        pivots = useResultKPivots(ask, layers, usedPivots);
    }

    int ind = l;
    vector <pair <int, int>> segments;

    for(int i = 0;i<pivots.size();i++)
    {
        pair <int, int> curr;
        curr.first = ind;

        for(int x: layers[i]) b[ind] = x, ind++;
        b[ind] = pivots[i];ind++;

        curr.second = ind - 2;
        segments.push_back(curr);
    }

    segments.push_back({ind, r});
    for(int x: layers.back()) b[ind] = x, ind++;

    //cout << "pivots: ";
    //for(int x: pivots) cout << x << " ";
    //cout << '\n';

    for(int i = l;i<=r;i++) a[i] = b[i];//, cout << a[i] << " ";
    //cout << '\n';

    for(pair <int, int> f: segments) quickSort2Pivot(f.first, f.second, k);

    //cout << pivot1 << " %% " << pivot2 << '\n';
    //cout << L.size() << " " << MID.size() << " " << R.size() << '\n';



    //quickSort2Pivot(last, ind-1)

    //quickSort2Pivot(l, lInd-1, k);
    //quickSort2Pivot(lInd+1, r, k);
}

vector <int> makeAnswer(int n)
{
    vector <int> out;
    for(int i = 0;i<n;i++) out.push_back(a[i]);

    return out;
}

vector<int> multisort(int n, int k)
{
    //cout << "n: " << n <<  '\n';

    for(int i = 0;i<n;i++) a[i] = i;
    shuffle(a, a+n, rnd);

    quickSort2Pivot(0, n-1, k);
    return makeAnswer(n);
}

