//#include "Lgrader.cpp"
#include "rain.h"

#include<iostream>
#include<vector>
#include<cmath>
#include<set>
#include<algorithm>

using namespace std;

const int MAXN = 2e3 + 5;
const double eps = 0.000000001;
const long long inf = 1e15 + 5;

int n, m;
vector <pair <int, long long>> graph[MAXN];

struct DSU
{
    int parent[MAXN];
    int treeSize[MAXN];

    vector <int> nodes[MAXN];
    vector <pair <int, long long>> graph[MAXN];

    double level[MAXN];

    DSU(){}
    DSU(int n)
    {
        for(int i = 1;i<=n;i++)
        {
            level[i] = 0;

            parent[i] = i;
            nodes[i] = {i};
            treeSize[i] = 1;
        }
    }

    void init(int n, vector <pair <int, long long>> *graph)
    {
        for(int i = 1;i<=n;i++)
        {
            level[i] = 0;
            if(this->graph[i].size()!=graph[i].size()) this->graph[i] = graph[i];

            parent[i] = i;
            nodes[i] = {i};
            treeSize[i] = 1;
        }
    }

    void addEdge(int u, int v, long long val)
    {
        graph[u].push_back({v, val});
        graph[v].push_back({u, val});
    }

    int Find(int x)
    {
        if(parent[x]==x) return x;

        parent[x] = Find(parent[x]);
        return parent[x];
    }

    void Union(int u, int v)
    {
        u = Find(u);
        v = Find(v);

        if(u==v) return;
        if(treeSize[u]<treeSize[v]) swap(u, v);

        parent[v] = u;
        treeSize[u] += treeSize[v];

        for(int x: nodes[v])
        {
            nodes[u].push_back(x);
            for(pair <int, long long> item: graph[x])
            {
                if(Find(item.first)!=u) graph[u].push_back(item);
            }
        }

        //sort(graph[u].begin(), graph[u].end());
        //unique(graph[u].begin(), graph[u].end());
    }

    bool used[MAXN];
    double rec(int x, double val)
    {
        x = Find(x);
        used[x] = true;

        int bestInd = -1;
        for(int i = 0;i<graph[x].size();i++)
        {
            if(Find(graph[x][i].first)==x) continue;

            if(bestInd==-1) bestInd = i;
            else if(graph[x][i].second<graph[x][bestInd].second) bestInd = i;
        }

        int nxt = ((bestInd==-1)?-1:graph[x][bestInd].first);

        long long minVal = inf;
        if(bestInd!=-1) minVal = graph[x][bestInd].second;

        double res = 1;
        if(nxt==-1 || level[x]+eps<double(minVal))
        {
            level[x] += val/treeSize[x];
            if(level[x]+eps<double(minVal)) res = (double(minVal) - level[x])*treeSize[x];
        }
        else
        {
            res = rec(nxt, val);
            if(abs(level[nxt]-level[x])<eps) Union(nxt, x);
        }

        return res;
    }
};

DSU T;

void init(int _n, int _m, int *a, int *b, long long *c)
{
    n = _n;
    m = _m;

    T = DSU(n);
    for(int i = 0;i<m;i++)
    {
        graph[ a[i] ].push_back({b[i], c[i]});
        graph[ b[i] ].push_back({a[i], c[i]});
    }
}

double query(long long w, int u)
{
    T.init(n, graph);

    long long jump = 1;
    for(long long iter = 0;iter<w;)
    {
        iter += jump;
        jump = round(T.rec(1, jump));
        jump = min(jump, w-iter);

        //cout << jump << '\n';
        //for(int x = 1;x<=n;x++) cout << x << " -> " << T.level[T.Find(x)] << '\n';

        //cout << " -------- " << '\n';
    }

    return T.level[T.Find(u)];
}
/*
3 2
1 2 1
1 3 5
*/
