#include "rain.h"

#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

const double LOW=1/1e6;

int n,m,inp[nmax];

struct edge
{
    int u,v;
    long long c;
};

edge all[nmax];
bool cmp(edge a,edge b)
{
    return a.c<b.c;
}
void init(int n_, int m_, int a_[], int b_[], long long c_[])
{

    n=n_;
    m=m_;

    for(int i=1;i<=m_;i++)
    {
        all[i].u=a_[i-1];
        all[i].v=b_[i-1];
        all[i].c=c_[i-1];
    }

    sort(all+1,all+m_+1,cmp);
}

double active[nmax];

bool push(int from,int to,long long cap)
{
    //cout<<"pushing "<<from<<" "<<to<<" "<<cap<<" with "<<active[from]<<" "<<active[to]<<endl;

    if(active[from]>=cap&&active[to]<cap)
    {
        double send=min(active[from]-cap,cap-active[to]);

        if(send>1)send=1;

        //cout<<"push "<<from<<" "<<to<<" "<<cap<<" "<<send<<endl;

        if(send<LOW)return 0;

        active[from]-=send;
        active[to]+=send;

        return 1;
    }
    return 0;
}
double query(long long water, int where)
{
    for(int i=1;i<=n;i++)active[i]=0;

    active[1]=water;

    while(1)
    {
        bool stop=1;
        for(int j=1;j<=m;j++)
        {
            int u=all[j].u;
            int v=all[j].v;
            long long c=all[j].c;

            //cout<<"testing "<<u<<" "<<v<<" "<<c<<endl;

            if(active[u]>=c&&active[v]>=c&&abs(active[u]-active[v])>LOW)
            {
                double sum=(active[u]+active[v])/2;

                active[u]=sum;
                active[v]=sum;
                stop=0;
                break;
            }
            else if(push(u,v,c)||push(v,u,c))
            {
                stop=0;
                break;
            }
        }

        if(stop)break;
    }
    return active[where];
}
/*
int main()
{
    int n=3,m=2,a[2]={1,1},b[2]={2,3};
    long long c[2]={1,5};

    init(n,m,a,b,c);

    cout<<query(2,1)<<endl;
    cout<<query(3,1)<<endl;
    cout<<query(14,3)<<endl;

    return 0;
}
*/
