#include "rain.h"

#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

const double LOW=1/1e6;

int n,m,inp[nmax];

struct edge
{
    int u,v;
    long long c;
};

edge all[nmax];
bool cmp(edge a,edge b)
{
    return a.c<b.c;
}
void init(int n_, int m_, int a_[], int b_[], long long c_[])
{

    n=n_;
    m=m_;

    for(int i=1;i<=m_;i++)
    {
        all[i].u=a_[i-1];
        all[i].v=b_[i-1];
        all[i].c=c_[i-1];
    }

    sort(all+1,all+m_+1,cmp);
}

double active[nmax];



void push(int from,int to,double send)
{
    if(send>1)send=1;

    //cout<<"push "<<from<<" "<<to<<" "<<send<<endl;

    active[from]-=send;
    active[to]+=send;
}

int parent[nmax];

int SZ[nmax];

int root(int node)
{
    if(node==parent[node])return node;
    parent[node]=root(parent[node]);
    return parent[node];
}

bool test_push(int from,int to,long long cap)
{
    from=root(from);
    to=root(to);
    //cout<<"pushing "<<from<<" "<<to<<" "<<cap<<" with "<<active[from]<<" "<<active[to]<<endl;

    if(active[from]/SZ[from]>=cap&&active[to]/SZ[to]<cap)
    {
        double send=min(active[from]-SZ[from]*cap,SZ[to]*cap-active[to]);

        push(from,to,send);

        //cout<<"push "<<from<<" "<<to<<" "<<cap<<" "<<send<<endl;

        if(send<LOW)return 0;

        return 1;
    }
    return 0;
}

void my_merge(int u,int v)
{
    u=root(u);
    v=root(v);

    if(u==v)return;

    parent[u]=v;
    SZ[v]+=SZ[u];
    active[v]+=active[u];
}
double query(long long water, int where)
{
    //system("pause");

    for(int i=1;i<=n;i++)active[i]=0,SZ[i]=1,parent[i]=i;

    while(water)
    {
        active[root(1)]++;
        water--;

    while(1)
    {

        //for(int i=1;i<=n;i++)cout<<active[i]<<" ";cout<<endl;

        bool stop=1;
        for(int j=1;j<=m;j++)
        {
            int u=all[j].u;
            int v=all[j].v;
            long long c=all[j].c;

            if(root(u)==root(v))continue;

            //cout<<"testing "<<u<<" "<<v<<" "<<c<<endl;

            if(active[u]/SZ[root(u)]>=c&&active[v]/SZ[root(v)]>=c&&abs(active[u]/SZ[root(u)]-active[v]/SZ[root(v)])>LOW)
            {
                my_merge(root(u),root(v));

                stop=0;
                break;
            }
            else if(test_push(u,v,c)||test_push(v,u,c))
            {
                stop=0;
                break;
            }
        }

        if(stop)break;
    }

    }

    where=root(where);

    return active[where]/SZ[root(where)];
}
/*
int main()
{
    int n=3,m=2,a[2]={1,1},b[2]={2,3};
    long long c[2]={1,5};

    init(n,m,a,b,c);

    cout<<query(2,1)<<endl;
    cout<<query(3,1)<<endl;
    cout<<query(14,3)<<endl;

    return 0;
}
*/
