#include "multisort.h"
#include <vector>
#include <iostream>
#include <queue>
using std::cout; using std::cin; using std::endl;

const int MAX_N = 20000 + 10;
std::vector<int> graph[MAX_N];
int N;
std::vector<int> parents;

void run(std::vector<int> &elems) {
	/*
	cout << "=== run ===" << endl;
	cout << "cmp with: ";
	for(auto x : elems) cout << x << ',';
	cout << endl;
	*/

	compare(elems);

	/*
	cout << "received: ";
	for(auto x : elems) cout << x << ',';
	cout << endl;
	*/

	for(int i = 0;i < elems.size()-1;i ++) {
		const int a = elems[i];
		const int b = elems[i+1];
		bool already = false;
		for(auto nei : graph[a]) {
			if(nei == b) {
				already = true;
				break;
			}
		}
		if(already) continue;
		graph[a].push_back(b);
		parents[elems[i+1]] ++;
	}
}

//bool used[MAX_N];
std::vector<int> groups[MAX_N];
bool ignore[MAX_N];
int topsort() {
	//std::fill(used, used + N, false);

	std::vector<int> queue;
	groups[0].clear();
	for(int i = 0;i < N;i ++) {if(ignore[i]) continue;
		if(parents[i] == 0) {
			queue.push_back(i);
			//used[i] = true;
			groups[0].push_back(i);
		}
	}

	std::vector<int> cp_parents = parents;

	int iteration = 0;
	std::vector<int> new_queue;
	while(true) {
		if(queue.size() == 0) break;
		iteration ++;
		groups[iteration].clear();
		for(auto curr : queue) {
			//cout << "it " << iteration << " " << curr << endl;
			for(auto i : graph[curr]) {
				if(ignore[i]) continue;
				cp_parents[i] --;
				//cout << i << "now has " << cp_parents[i] << " parents " << endl;
				if(cp_parents[i] == 0) {
					new_queue.push_back(i);
					groups[iteration].push_back(i);
				}
			}
		}
		queue = new_queue;
		new_queue.clear();
	}

	return iteration;
}

std::vector<int> multisort(int n, int k) {
	N = n;
	parents.resize(N);

	// initial
	for(int offset = 0;offset < n;offset += k) {
		std::vector<int> v;
		for(int i = 0;offset+i < n and i < k;i ++) {
			v.push_back(offset + i);
		}
		//for(auto x : v) cout << x << ',';
		//cout << endl;
		run(v);
	}

	std::vector<int> ans;
	bool clean = true;
	while(true) {
		int gc = topsort();
		std::vector<int> v;
		for(int i = 0;i < gc;i ++) {

			//cout << "in group " << i << ": ";
			//for(auto x : groups[i]) cout << x << ',';
			//cout << endl;

			bool exit = false;
			if(groups[i].size() == 1) {
				if(clean and !ignore[groups[i][0]]) ans.push_back(groups[i][0]);
				ignore[groups[i][0]] = true;
				for(auto x : graph[groups[i][0]]) parents[x] --;
				continue;
			}
			clean = false;
			for(auto x : groups[i]) {
				if(v.size() < k) v.push_back(x);
				else {
					exit = true;
					break;
				}
			}
			if(exit) break;
		}
		if(v.size() == 0) break;
		run(v);
	} 
	return res;
}
