#include"rain.h"
#include<vector>
#include<stack>
#include<algorithm>
#include<iostream>
#include<iomanip>
using namespace std;
const int maxn = 200;
int n, m;
vector<pair<long double,int> > e[maxn];

void init(int _n, int _m, int _a[], int _b[], long long _c[])
{
    n = _n;
    m = _m;
    for(int i = 0; i < m; i ++)
    {
        _a[i]--;
        _b[i]--;
        e[_a[i]].push_back({_c[i], _b[i]});
        e[_b[i]].push_back({_c[i], _a[i]});
    }
    for(int i = 0; i < n; i ++)
    {
        sort(e[i].begin(), e[i].end());
    }
    cerr << setprecision(4) << fixed;
}

long double vol[maxn];
stack<int> to_update;
bool update(int x)
{
    for(auto i: e[x])
    {
        if(vol[x] <= i.first)   return false;
        if(vol[i.second] < vol[x])
        {
            long double change = min(vol[x] - i.first, (vol[x] + vol[i.second]) / 2 - vol[i.second]);
            if(change < 1e-6)  continue;
            //cerr << "!!" << x << "->" << i.second << " " << change << endl;
            vol[i.second] += change;
            vol[x] -= change;
            to_update.push(x);
            to_update.push(i.second);
            return true;
        }
    }
    return false;
}

double query(long long w, int _ind)
{
    _ind --;
    for(int i = 0; i < n; i ++)
    {
        vol[i] = 0;
    }
    vol[0] = w;
    to_update.push(0);
    bool bb;
    do
    {
        while(!to_update.empty())
        {
            int u = to_update.top();
            to_update.pop();

            update(u);
        }
        bb = false;
        for(int i = 0; i < n; i ++)
        {
            if(update(i))
            {
                bb = true;
                break;
            }
        }
    }while(bb);
    /*for(int i = 0; i < n; i ++)
    {
        cerr << vol[i] << " ";
    }
    cerr << endl;*/
    return vol[_ind];
}

/**
3 2
1 2 1
1 3 5
3
2 1
3 1
14 3
*/
