#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int k_N = 5e4 + 3;

set<int> s;
int a[k_N], b[k_N];

int n, xa;
int m, xb;

pair<int, int> lines[2 * k_N];

struct DSU{
    int p[2 * k_N], sz[2 * k_N];

    DSU(){}

    int get_p(int x){
        if(x == p[x]) return x;
        return p[x] = get_p(p[x]);
    }

    bool unite(int u, int v){
        if(get_p(u) == get_p(v))
            return false;

        if(sz[p[u]] < sz[p[v]])
            swap(u, v);

        sz[p[u]] += sz[p[v]];
        p[p[v]] = p[u];
        return true;
    }
}dsu;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> xa;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        a[i] /= 2;
        lines[i] = make_pair(xa - a[i], xa + a[i]);
        s.insert(xa + a[i]);
        s.insert(xa - a[i]);
    }

    cin >> m >> xb;
    for(int i = 0; i < m; ++i){
        cin >> b[i];
        b[i] /= 2;
        lines[i + n] = make_pair(xb - b[i], xb + b[i]);
        s.insert(xb - b[i]);
        s.insert(xb + b[i]);
    }

    sort(lines, lines + n + m);

    for(int i = 0; i < n + m; ++i){
        dsu.p[i] = i;
        dsu.sz[i] = 1;
    }

    for(int i = 0; i < n + m; ++i){
        for(int j = i + 1; j < n + m; ++j){
            if(lines[i].second >= lines[j].first && lines[i].second <= lines[j].second){
                dsu.unite(i, j);
            }
        }
    }

    int ans = (int)s.size() - 1;
    for(int i = 0; i < n + m; ++i){
        for(int j = i + 1; j < n + m; ++j){
            if(i == j) continue;

            if(lines[j].first <= lines[i].second && dsu.get_p(i) != dsu.get_p(j)){
                ans -= 2;
                //cout << i << " i " << j << "\n";
                break;
            }
        }
    }

    cout << ans << "\n";
}
