#include <iostream>
#include <vector>
#include "multisort.h"

using namespace std;

void compare(vector<int>& elems);

vector<int> v;
int n, k;

void merge_sort(int l, int r){
    if(r - l + 1 <= k){
        vector<int> new_v;
        for(int i = l; i <= r; ++i)
            new_v.push_back(v[i]);
        compare(new_v);
        for(int i = l; i <= r; ++i)
            v[i] = new_v[i - l];
        return;
    }

    int mid = (l + r) >> 1;
    merge_sort(l, mid);
    merge_sort(mid + 1, r);

    int ptr1 = l, ptr2 = mid + 1;
    vector<int> new_v;
    while(ptr1 != mid + 1 && ptr2 != r + 1){
        vector<int> t;
        t.push_back(v[ptr1]);
        t.push_back(v[ptr2]);
        compare(t);

        new_v.push_back(t[0]);
        if(t[0] == v[ptr1]) ptr1++;
        else ptr2++;
    }

    while(ptr1 != mid + 1)
        new_v.push_back(v[ptr1++]);
    while(ptr2 != r + 1)
        new_v.push_back(v[ptr2++]);

    for(int i = l; i <= r; ++i)
        v[i] = new_v[i - l];
}

vector<int> multisort(int _n, int _k){
    n = _n;
    k = _k;

    for(int i = 0; i < n; ++i)
        v.push_back(i);
    merge_sort(0, n - 1);
    return v;
}
