#include <iostream>
#include <vector>
#include "multisort.h"

using namespace std;

void compare(vector<int>& elems);

const int k_N = 20000 + 3;

vector<int> v;
int n, k;

int pos[k_N];

void merge_sort(int l, int r){
    if(l == r) return;
    if(r - l + 1 <= k){
        vector<int> new_v;
        for(int i = l; i <= r; ++i)
            new_v.push_back(v[i]);
        compare(new_v);
        for(int i = l; i <= r; ++i)
            v[i] = new_v[i - l];
        return;
    }

    int x = (r - l + 1) / k;
    int cnt1 = (r - l + 1) % k;
    int cnt2 = k - cnt1;

    vector<int> ptr, en;
    int curr = l;
    for(int i = 0; i < cnt1; ++i){
        en.push_back(curr);
        ptr.push_back(curr + x);
        merge_sort(curr, curr + x);
        curr += x + 1;
    }
    for(int i = 0; i < cnt2; ++i){
        en.push_back(curr);
        ptr.push_back(curr + x - 1);
        merge_sort(curr, curr + x - 1);
        curr += x;
    }

    vector<int> t, new_v;
    for(int i = 0; i < cnt1 + cnt2; ++i){
        pos[v[ptr[i]]] = i;
        t.push_back(v[ptr[i]]);
    }

    while(!t.empty()){
        compare(t);
        new_v.push_back(t.back());
        int p = pos[t.back()];
        ptr[p]--;
        if(ptr[p] >= en[p]){
            t.push_back(v[ptr[p]]);
            pos[v[ptr[p]]] = p;
        }
    }

    reverse(new_v.begin(), new_v.end());
    for(int i = l; i <= r; ++i)
        v[i] = new_v[i - l];
}

vector<int> multisort(int _n, int _k){
    n = _n;
    k = _k;

    for(int i = 0; i < n; ++i)
        v.push_back(i);
    merge_sort(0, n - 1);
    return v;
}
