//#include <bits/stdc++.h>
#include <vector>
#include <iostream>
#include <algorithm>
#include <utility>
#include <math.h>
#include <random>
#include "multisort.h"

using namespace std;

void compare(vector<int>& elems);

const int k_N = 20000 + 3;

vector<int> v;
int n, k;

int pos[k_N];

mt19937 mt(9);

int rnd(int mod){
    return mt() % mod;
}

void merge_sort(int l, int r){
    if(l >= r) return;
    if(r - l + 1 <= k){
        vector<int> new_v;
        for(int i = l; i <= r; ++i)
            new_v.push_back(v[i]);
        compare(new_v);
        for(int i = l; i <= r; ++i)
            v[i] = new_v[i - l];
        return;
    }

    int cnt;
    if(k <= 100) cnt = sqrt(k);
    else cnt = k / 100;
    random_shuffle(v.begin() + l, v.begin() + r + 1, rnd);

    vector<int> pivots;
    for(int i = l; i < l + cnt; ++i)
        pivots.push_back(v[i]);
    compare(pivots);

    vector<vector<int> > t(cnt + 1);
    vector<int> p;
    for(int i = l + cnt; i <= r; ++i){
        p.push_back(v[i]);
        if(p.size() == k - cnt){
            for(int j = 0; j < cnt; ++j)
                p.push_back(pivots[j]);
            compare(p);
            int ptr = 0;
            for(int j = 0; j < p.size(); ++j){
                if(ptr != cnt && p[j] == pivots[ptr])
                    ptr++;
                else
                    t[ptr].push_back(p[j]);
            }
            p.clear();
        }
    }

    if(!p.empty()){
        for(int j = 0; j < cnt; ++j)
            p.push_back(pivots[j]);
        compare(p);
        int ptr = 0;
        for(int j = 0; j < p.size(); ++j){
            if(ptr != cnt && p[j] == pivots[ptr])
                ptr++;
            else
                t[ptr].push_back(p[j]);
        }
        p.clear();
    }

    int ptr = l, prev = l;
    for(int i = 0; i < cnt + 1; ++i){
        for(int j = 0; j < t[i].size(); ++j)
            v[ptr++] = t[i][j];
        merge_sort(prev, ptr - 1);
        if(i != cnt)
            v[ptr++] = pivots[i];
        prev = ptr;
    }
}

vector<int> multisort(int _n, int _k){
    n = _n;
    k = _k;

    for(int i = 0; i < n; ++i)
        v.push_back(i);
    merge_sort(0, n - 1);
    return v;
}
