#include <iostream>
#include <vector>
#include <utility>
#include <queue>

using namespace std;

const int k_N = 3e5 + 3;

int n, m;
vector<pair<int, long long> > adj[k_N];
bool vis[k_N];
long long r[k_N];

double query (long long W, int K){
    priority_queue<pair<long long, int>, vector<pair<long long, int> >, greater<pair<long long, int> > > pq;
    for(int i = 1; i <= n; ++i){
        vis[i] = false;
        r[i] = 0;
    }

    pq.push(make_pair(0, 1));
    vector<int> v;
    while(!pq.empty()){
        pair<long long, int> p = pq.top();
        pq.pop();

        int node = p.second;

        if(vis[node]) continue;
        vis[node] = true;

        long long mx = 0;
        int i;
        for(i = (int)v.size() - 1; i >= 0; --i){
            if(r[v[i]] >= p.first) break;
            if(i == 0 || r[v[i]] != r[v[i - 1]]){
                long long nxt;
                if(i == 0) nxt = p.first;
                else nxt = min(r[v[i - 1]], p.first);

                long long cost = (long long)((int)v.size() - i) * (nxt - mx);
                if(cost <= W) mx = nxt;
                else{
                    double cnt = (int)v.size() - i;
                    double add = (double)W / cnt;
                    for(int j = i; j < v.size(); ++j)
                        if(v[j] == K)
                            return add + (double)r[j];
                    return (double)r[K];
                }
            }
        }

        ++i;
        for(; i < v.size(); ++i)
            r[v[i]] = p.first;

        v.push_back(node);
        for(int j = 0; j < adj[node].size(); ++j){
            pair<int, long long> p = adj[node][j];
            pq.push(make_pair(p.second, p.first));
        }
    }

    for(int i = 0; i < v.size(); ++i)
        if(v[i] == K)
            return (double)r[i] + (double)W / (double)(v.size());

    return (double)0;
}

void init (int N, int M, int a[], int b[], long long c[]){
    n = N;
    m = M;

    for(int i = 0; i < m; ++i){
        adj[a[i]].push_back(make_pair(b[i], c[i]));
        adj[b[i]].push_back(make_pair(a[i], c[i]));
    }
}

