#include <iostream>
#include <vector>
#include <utility>
#include <queue>
#include "rain.h"

using namespace std;

const int k_N = 3e5 + 3;

int n, m;
vector<pair<int, long long> > adj[k_N];
bool vis[k_N];
long long r[k_N];

vector<int> v;

pair<bool, double> push_rain(long long x, long long &W, int K){
    if(v.empty()) return make_pair(false, 0);

    int i;
    long long mx = r[v.back()];
    for(i = (int)v.size() - 1; i >= 0; --i){
        if(r[v[i]] >= x) break;
        if(i == 0 || r[v[i]] != r[v[i - 1]]){
            long long nxt;
            if(i == 0) nxt = x;
            else nxt = min(r[v[i - 1]], x);

            long long cost = (long long)((int)v.size() - i) * (nxt - mx);
            if(cost <= W){
                mx = nxt;
                W -= cost;
            }
            else{
                for(int j = i; j < v.size(); ++j)
                    r[j] = mx;

                double cnt = (int)v.size() - i;
                double add = (double)W / cnt;
                for(int j = i; j < v.size(); ++j)
                    if(v[j] == K)
                        return make_pair(true, add + (double)r[K]);
                return make_pair(true, (double)r[K]);
            }
        }
    }

    ++i;
    for(; i < v.size(); ++i)
        r[v[i]] = x;

    return make_pair(false, 0);
}

double query (long long W, int K){
    priority_queue<pair<long long, int>, vector<pair<long long, int> >, greater<pair<long long, int> > > pq;
    for(int i = 1; i <= n; ++i){
        vis[i] = false;
        r[i] = 0;
    }
    v.clear();

    pq.push(make_pair(0, 1));

    while(!pq.empty()){
        pair<long long, int> p = pq.top();
        pq.pop();

        //for(int i = 0; i < v.size(); ++i)
        //    cout << v[i] << " - " << r[v[i]] << "\n";
        //cout << "\n";

        int node = p.second;

        if(vis[node]) continue;
        vis[node] = true;

        pair<bool, double> ans = push_rain(p.first, W, K);
        if(ans.first)
            return ans.second;

        v.push_back(node);
        for(int j = 0; j < adj[node].size(); ++j){
            pair<int, long long> p = adj[node][j];
            pq.push(make_pair(p.second, p.first));
        }
    }

    pair<bool, double> ans = push_rain(r[v[0]], W, K);
    if(ans.first)
        return ans.second;

    for(int i = 0; i < v.size(); ++i)
        if(v[i] == K)
            return (double)r[K] + (double)W / (double)(v.size());

    return (double)0;
}

void init (int N, int M, int a[], int b[], long long c[]){
    n = N;
    m = M;

    for(int i = 0; i < m; ++i){
        adj[a[i]].push_back(make_pair(b[i], c[i]));
        adj[b[i]].push_back(make_pair(a[i], c[i]));
    }
}



