#include <bits/stdc++.h>
#include "rain.h"

using namespace std;

const int maxn = 3e5 + 3;
const double eps = 0.00001;

struct edge
{
    int a, b;
    long long c;
    bool operator < (const edge &t) const
    {
        return c < t.c;
    }
};

edge edges[maxn];
int nn, mm;
void init(int n, int m, int a[], int b[], long long c[])
{
    nn = n;
    mm = m;
    for (int i = 1; i <= m; i++)
    edges[i] = {a[i-1], b[i-1], c[i-1]};

    sort (edges + 1, edges + m + 1);
}

double ans[maxn];
double query(long long w, int k)
{
    for (int i = 1; i <= nn; i++)
        ans[i] = 0;

    ans[1] = w;
    for (;;)
    {
        bool is = false;
        for (int i = 1; i <= mm; i++)
        {
            if (fabs(ans[edges[i].a] - ans[edges[i].b]) < eps)
                continue;

            if (ans[edges[i].a] < ans[edges[i].b])
                swap(edges[i].a, edges[i].b);

            double t = min(ans[edges[i].a] - edges[i].c, (ans[edges[i].a] - ans[edges[i].b]) / 2.0);
            if (t > 0)
            {
                is = true;
                ans[edges[i].a] -= t;
                ans[edges[i].b] += t;
            }
        }

        if (!is)
            break;
    }

    return ans[k];
}

/*
int main()
{
    int n, m, a[1003], b[1003];
    long long c[1003];
    cin >> n >> m;
    for (int i = 0; i < m; i++)
        cin >> a[i] >> b[i] >> c[i];

    init(n, m, a, b, c);

    int q;
    cin >> q;
    while (q--)
    {
        long long w;
        int k;
        cin >> w >> k;

        cout << query(w, k) << endl;
    }
}
*/
