#include <bits/stdc++.h>
using namespace std;

void init(int, int, int[], int[], long long[]);
double query(long long, int);

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 3e5 + 10;

struct Comp {
    priority_queue<pair<int, int>, vector<pair<int, int> >, greater<pair<int, int> > > pq;
    int sz, par, w;
    Comp() {sz = par = w = 0;}
    int sum() {
        return sz + pq.size();
    }
};

Comp dsu[MAX_N];
vector<int> st;

int find(int x) {
    if(dsu[x].par == x) {return x;}
    int now = find(dsu[x].par);
    dsu[x].par = now;
    while(!dsu[x].pq.empty()) {
        dsu[now].pq.push(dsu[x].pq.top());
        dsu[x].pq.pop();
    }
    return now;
}

bool merge(int x, int y) {
    x = find(x);
    y = find(y);
    if(x == y) {return false;}
    if(dsu[x].sum() < dsu[y].sum()) {swap(x, y);}
    while(!dsu[y].pq.empty()) {
        dsu[x].pq.push(dsu[y].pq.top());
        //cout << "Moving " << x << " " << y << " " << dsu[y].pq.top().first << " " << dsu[y].pq.top().first << endl;
        dsu[y].pq.pop();
    }
    dsu[y].par = x;
    dsu[x].sz += dsu[y].sz;
    return true;
}

int A[MAX_N], B[MAX_N], C[MAX_N];
int N, M;
ll last;
ll lft = 0;
bool used[MAX_N];

void start() {
    for(int i = 0; i <= N; i ++) {
        while(!dsu[i].pq.empty()) {
            dsu[i].pq.pop();
        }
    }
    for(int i = 0; i < M; i ++) {
        dsu[A[i]].pq.push({C[i], B[i]});
        dsu[B[i]].pq.push({C[i], A[i]});
        //cout << "Edge " << A[i] << " " << B[i] << endl;
    }
    for(int i = 1; i <= N; i ++) {
        dsu[i].par = i;
        dsu[i].sz = 1;
        dsu[i].w = 0;
        used[i] = false;
    }
    used[1] = true;
    last = 0;
    lft = 0;
    while(!st.empty()) {st.pop_back();}
    st.push_back(1);
}

void init(int n, int m, int a[], int b[], long long c[]) {
    N = n;
    M = m;
    for(int i = 0; i < m; i ++) {
        A[i] = a[i];
        B[i] = b[i];
        C[i] = c[i];
    }
    start();
}

double query(ll W, int k) {
    if(W >= last)  {
        lft += W - last;
        last = W;
    } else {
        start();
    }
    while(true) {
        int now = st.back();
        if(dsu[now].pq.empty()) {break;}
        int need = dsu[now].pq.top().first;
        //cout << now << " " << need << " " << lft << " " << dsu[now].pq.top().first << " " << dsu[now].pq.top().second << endl;
        if(st.size() > 1) {chkmin(need, dsu[st[st.size() - 2]].w);}
        if(lft >= (need - dsu[now].w) * dsu[now].sz) {
            lft -= (need - dsu[now].w) * dsu[now].sz;
            dsu[now].w = need;
        } else {
            break;
        }
        //cout << "Here " << endl;
        if(st.size() > 1 && dsu[now].w == dsu[st[st.size() - 2]].w) {
            merge(st[st.size() - 2], now);
            st.pop_back();
            st[st.size() - 1] = find(now);
            //cout << "Merged with parent" << endl;
            continue;
        } else {
            int other = dsu[now].pq.top().second;
            if(!used[other]) {
                st.push_back(other);
                //cout << "Found new " << other << endl;
                used[other] = true;
            } else {
                dsu[now].pq.pop();
            }
        }
    }
    //cout << "Here " << endl;
    int par = find(k);
    //cout << "Parent " << k << " " << st.back() << endl;
    if(par == st.back()) {
        return (ld)dsu[st.back()].w + (ld)((ld)lft / (ld)dsu[st.back()].sz);
    } else {
        return dsu[par].w;
    }
}
