#include <bits/stdc++.h>
#include "rain.h"
using namespace std;
long long n, m;
struct edge{
    long long u, v;
    long long w;
    bool operator < (edge oth) const{
        return w < oth.w;
    }
};
vector <edge> edges;
long long par [300005], depth [300005], compsz [300005];
long long maxe [300005];
struct merge_edge{
    long long u, du, su;
    long long mu;
    long long v, dv, sv;
    long long mv;
    long long idx;
};
stack <merge_edge> st;
long long lastrm;
long long root (long long i){
    if (par [i] == i) return i;
    else return root (par [i]);
}
void Merge (long long ru, long long rv, long long idx){
    st.push ({ru, depth [ru], compsz [ru], maxe [ru], rv, depth [rv], compsz [rv], maxe [rv], idx});
    if (depth [ru] < depth [rv]) par [ru] = rv, compsz [rv] += compsz [ru], maxe [rv] = max (max (maxe [rv], maxe [ru]), edges [idx].w);
    else if (depth [rv] < depth [ru]) par [rv] = ru, compsz [ru] += compsz [rv], maxe [ru] = max (max (maxe [rv], maxe [ru]), edges [idx].w);
    else{
        par [ru] = rv;
        depth [rv] ++;
        compsz [rv] += compsz [ru];
        max (max (maxe [rv], maxe [ru]), edges [idx].w);
    }
}
void rollback (){
    merge_edge e = st.top ();
    st.pop ();
    par [e.u] = e.u;
    depth [e.u] = e.du;
    compsz [e.u] = e.su;
    maxe [e.u] = e.mu;
    par [e.v] = e.v;
    depth [e.v] = e.dv;
    compsz [e.v] = e.sv;
    maxe [e.v] = e.mv;
    lastrm = e.idx;
}
void init (int N, int M, int a [], int b [], long long c []){
    n = N;
    m = M;
    for (long long i = 0; i < M; i ++){
        edges.push_back ({a [i], b [i], c [i]});
    }
    sort (edges.begin (), edges.end ());
    for (long long i = 1; i <= n; i ++){
        par [i] = i;
        depth [i] = 1;
        compsz [i] = 1;
        maxe [i] = 0;
    }
}
long double query (long long W, int k){
    long double w = W;
    while (!st.empty ()) rollback ();
    long long source = 1;
    long long I = -1;
    for (long long i = 0; i < m; i ++){
        edge e = edges [i];
        long long ru = root (e.u), rv = root (e.v);
        if (ru == rv) continue;
        if (ru != source && rv != source){
            Merge (ru, rv, i);
            continue;
        }
        if (rv == source) swap (ru, rv);
        if ((long double) compsz [ru] * (long double) e.w >= w){
            if (root (k) == ru) return w / (long double) compsz [ru];
            else return 0.0;
        }
        if ((long double) (compsz [ru] + compsz [rv]) * (long double) e.w <= w){
            Merge (ru, rv, i);
            source = root (source);
        }
        else{
            if (root (k) == ru) return e.w;
            if (ru == root (e.u)) source = e.v;
            else source = e.u;
            w -= (long double) compsz [ru] * (long double) e.w;
            while ((long double) compsz [root (source)] * (long double) maxe [root (source)] > w) rollback ();
            source = root (source);
            I = i;
            i = lastrm - 1;
            continue;
        }
        if (I != -1){
            i = I;
            I = -1;
        }
    }
    return w / (long double) compsz [source];
}
/*
long long main (){

	ios::sync_with_stdio (false);
	cin.tie (0);



}*/
