#include <bits/stdc++.h>
#include "multisort.h"

#pragma GCC optimize "-O3"

int K;
std::vector<int> perm;

void merge(int low, int high) {
    std::vector<int> order;
    int mid = (low + high) / 2;
    int ptr_left = low, ptr_right = mid + 1;

    while (ptr_left <= mid && ptr_right <= high) {
        std::vector<int> query_order = {perm[ptr_left], perm[ptr_right]};

        compare(query_order);

        if (query_order[0] == perm[ptr_left]) {
            order.emplace_back(perm[ptr_left]);
            ptr_left++;
        } else {
            order.emplace_back(perm[ptr_right]);
            ptr_right++;
        }
    }

    while (ptr_left <= mid) {
        order.emplace_back(perm[ptr_left]);
        ptr_left++;
    }

    while (ptr_right <= high) {
        order.emplace_back(perm[ptr_right]);
        ptr_right++;
    }

    for (int i = low; i <= high; i++) {
        perm[i] = order[i - low];
    }
}

void merge_sort(int low, int high) {
    if (high - low + 1 <= K) {
        std::vector<int> order;
        for (int i = low; i <= high; i++) {
            order.emplace_back(perm[i]);
        }

        compare(order);

        for (int i = low; i <= high; i++) {
            perm[i] = order[i - low];
        }

        return;
    }

    int mid = (low + high) / 2;
    merge_sort(low, mid);
    merge_sort(mid + 1, high);

    merge(low, high);
}

std::vector<int> multisort(int n, int k) {
    K = k;

    perm.resize(n);
    for (int i = 0; i < n; i++) {
        perm[i] = i;
    }

    merge_sort(0, n - 1);

    return perm;
}
