#include <bits/stdc++.h>
#include "multisort.h"

#pragma GCC optimize "-O3"

int K;
std::vector<int> perm;

void merge(int lf, int lt, int rf, int rt) {
    std::vector<int> order;
    int ptr_left = lf, ptr_right = rf;

    while (ptr_left <= lt && ptr_right <= rt) {
        std::vector<int> query = {perm[ptr_left], perm[ptr_right]};
        compare(query);

        if (query[0] == perm[ptr_left]) {
            order.emplace_back(perm[ptr_left]);
            ptr_left++;
        } else {
            order.emplace_back(perm[ptr_right]);
            ptr_right++;
        }
    }

    while (ptr_left <= lt) {
        order.emplace_back(perm[ptr_left]);
        ptr_left++;
    }

    while (ptr_right <= rt) {
        order.emplace_back(perm[ptr_right]);
        ptr_right++;
    }

    for (int i = lf; i <= rt; i++) {
        perm[i] = order[i - lf];
    }
}

std::vector<int> multisort(int n, int k) {
    K = k;

    perm.resize(n);
    for (int i = 0; i < n; i++) {
        perm[i] = i;
    }

    for (int i = 0; i < n; i += k) {
        std::vector<int> order;
        for (int j = i; j <= std::min(n - 1, i + k - 1); j++) {
            order.emplace_back(perm[j]);
        }

        if (order.size() > 1) {
            compare(order);
        }

        for (int j = i; j <= std::min(n - 1, i + k - 1); j++) {
            perm[j] = order[j - i];
        }
    }

    int len = k;
    for (int i = k; i < n; i += k) {
        merge(0, len - 1, i, std::min(i + k - 1, n - 1));
        len += k;
    }

    return perm;
}
