#include <bits/stdc++.h>
#include "rain.h"

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n;
vector<set<pair<int, int>>> adj_list;

vector<double> amount;
vector<bool> seen;

void init (int N, int M, int a[], int b[], long long c[]) {
    n = N;

    adj_list.resize(n + 1);
    for (int i = 0; i < M; i++) {
        adj_list[a[i]].emplace(c[i], b[i]);
        adj_list[b[i]].emplace(c[i], a[i]);
    }

    amount.resize(n + 1);
    seen.resize(n + 1);
}

void dfs(int node) {
    seen[node] = true;

    for (auto &adj_node : adj_list[node]) {
        if (seen[adj_node.second]) {
            continue;
        }

        if (amount[node] > adj_node.first) {
            double add = (amount[node] - adj_node.first + 1) / 2;
            amount[node] -= add;
            amount[adj_node.second] += add;

            dfs(adj_node.second);
        }
    }
}

double query (long long W, int K) {
    fill(seen.begin(), seen.end(), false);
    amount[1] = W;

    dfs(1);

    return amount[K];
}
