#include "rain.h"
//#include "Lgrader.cpp"

#include <bits/stdc++.h>
#define fi first
#define se second
using namespace std;

const int MAXN = 300005;
const long long INF = 1ll << 60;

int n, m;
vector<pair<int, long long>> g[MAXN];

struct vertex_set
{
    long long lev;
    priority_queue<pair<long long, pair<int, int>>> pq; // next edge time, <from, index>
    vector<int> ver;
};

struct node
{
    int lch, rch;
    long long val;
};

struct data
{
    int sz, lm, rt;
    data(int sz, int lm, int rt)
    {
        this -> sz = sz;
        this -> lm = lm;
        this -> rt = rt;
    }
    data(){}
};

vector<vertex_set> st;
vector<int> order;
int ord_pos[MAXN];
int vis[MAXN];

vector<node> tree;
map<long long, data> mp;
int root = -1;

void update(int v, int le, int ri, long long add, int l = 0, int r = n - 1)
{
    // create new children
    if (l != r)
    {
        tree.emplace_back();
        if (tree[v].lch != 0) tree.back() = tree[tree[v].lch];
        tree[v].lch = tree.size() - 1;
        tree.emplace_back();
        if (tree[v].rch != 0) tree.back() = tree[tree[v].rch];
        tree[v].rch = tree.size() - 1;
    }

   if (ri < l or le > r) return;
   if (le <= l and r <= ri)
   {
       tree[v].val += add;
       return;
   }

   int mid = (l + r) / 2;
   update(tree[v].lch, le, ri, add, l, mid + 0);
   update(tree[v].lch, le, ri, add, mid + 1, r);
}

long long query(int v, int x, int l = 0, int r = n - 1)
{
    if (x < l or x > r) return 0;
    if (x == l and x == r) return tree[v].val;

    int mid = (l + r) / 2;
    if (x <= mid) return tree[v].val + query(tree[v].lch, x, l, mid + 0);
    else return tree[v].val + query(tree[v].rch, x, mid + 1, r);
}

void Prepare()
{
    st.emplace_back();
    st.back().lev = 0;
    st.back().ver.push_back(1);
    if (g[1].size() != 0) st.back().pq.emplace(-g[1][0].se, make_pair(1, 0));
    vis[1] = 1;
    order.push_back(1);

    long long W = 0;
    while (true)
    {
        long long new_lev = INF, old_lev = INF;
        if (st.back().pq.size() != 0) new_lev = -st.back().pq.top().fi;
        if (st.size() > 1) old_lev = st[st.size() - 2].lev;

        if (new_lev == INF and old_lev == INF) break;
        data elem;
        elem.rt = root;
        elem.lm = order.size() - 1;
        elem.sz = st.back().ver.size();
        mp[W] = elem;

        if (old_lev <= new_lev)
        {
            W += (old_lev - st.back().lev) * st.back().ver.size(); // update

            // create new root
            tree.emplace_back();
            if (root != -1) tree.back() = tree[root];
            root = tree.size() - 1;

            update(root, order.size() - st.back().ver.size(), order.size() - 1, old_lev - st.back().lev);


           // cout << W << " old" << endl;

            if (st.back().pq.size() > st[st.size() - 2].pq.size()) swap(st.back().pq, st[st.size() - 2].pq);
            while (st.back().pq.size() != 0)
            {
                st[st.size() - 2].pq.push(st.back().pq.top());
                st.back().pq.pop();
            }
            if (st.back().ver.size() > st[st.size() - 2].ver.size()) swap(st.back().ver, st[st.size() - 2].ver);
            while (st.back().ver.size() != 0)
            {
                st[st.size() - 2].ver.push_back(st.back().ver.back());
                st.back().ver.pop_back();
            }
            st.pop_back();
        }
        else
        {
            W += (new_lev - st.back().lev) * st.back().ver.size(); // update
            st.back().lev = new_lev;

             // create new root
            tree.emplace_back();
            if (root != -1) tree.back() = tree[root];
            root = tree.size() - 1;

            update(root, order.size() - st.back().ver.size(), order.size() - 1, new_lev - st.back().lev);

           /* cout << W << " new" << endl;
            cout << "from " << st.back().pq.top().se.fi << "to " << g[st.back().pq.top().se.fi][st.back().pq.top().se.se].fi << endl;
*/
            vertex_set ns;
            ns.lev = 0;
            while (st.back().pq.size() != 0 and -st.back().pq.top().fi == new_lev)
            {
                auto edge = st.back().pq.top();
                st.back().pq.pop();
                if (g[edge.se.fi].size() > edge.se.se + 1)
                {
                    st.back().pq.emplace(-g[edge.se.fi][edge.se.se + 1].se, make_pair(edge.se.fi, edge.se.se + 1));
                }

                int new_ver = g[edge.se.fi][edge.se.se].fi;

                if (vis[new_ver] != 0) continue;
                else vis[new_ver] = 1;
                order.push_back(new_ver);

                ns.ver.push_back(new_ver);
                if (g[new_ver].size() != 0) ns.pq.emplace(-g[new_ver][0].se, make_pair(new_ver, 0));
            }

            if (ns.ver.size() != 0) st.push_back(ns);
        }
    }

}

bool comp(pair<int, long long> x, pair<int, long long> y)
{
    return x.se < y.se;
}

void init(int N, int M, int a[], int b[], long long c[])
{
    n = N; m = M;

    for (int i = 0; i < M; ++ i)
    {
        g[a[i]].emplace_back(b[i], c[i]);
        g[b[i]].emplace_back(a[i], c[i]);
    }

    for (int i = 1; i <= N; ++ i)
    {
        sort(g[i].begin(), g[i].end(), comp);
    }

    //cout << endl;

    Prepare();

    //cout << endl;
    for (int i = 0; i < order.size(); ++ i)
    {
       // cout << order[i] << ' ';
        ord_pos[order[i]] = i;
    }
   // cout << endl;
}

double query(long long W, int K)
{
    auto iter = --mp.upper_bound(W);

    long long Wprim = iter->fi;
    int sz = (iter->se).sz;
    int lm = (iter->se).lm;
    int rt = (iter->se).rt;

   /* cout << "query: " << W << ' ' << K << endl;
    cout << Wprim << ' ' << sz << ' ' << lm << ' ' << rt << endl;*/

    int pos = ord_pos[K];
    if (pos > lm) return 0;

    Wprim = W - Wprim;

    return query(rt, K) + 1.0 * Wprim / sz;
}


/*
3 2
1 2 1
1 3 5
3
2 1
3 1
14 3
*/

